﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.5
@EndOfDesignText@
Sub Class_Globals
	Public ID As String
	Private BANano As BANano
	Public TypeOf As String
	Public Template As String
	Public Columns As List
	Public Width As Int
	Public Height As Int
	Public Rows As List
	Private Element As Map
	Public Value As String
	Public Elements As List
	Public Name As String
	Private Attributes As Map
End Sub

Public Sub Initialize(sID As String)
	ID = sID.ToLowerCase
	Columns.Initialize
	Width = 0
	Height = 0
	TypeOf = ""
	Rows.Initialize
	Elements.Initialize 
	Element = CreateMap()
	Element.Put("id",ID)
	Value = ""
	Name = ""
	Attributes.Initialize 
End Sub

Sub SetAttr(attrName As String, attrValue As Object)
	SetOnContent(attrName,attrValue)
End Sub

Sub Item As Map
	SetOnCondition(Height,"height",Height)
	SetOnCondition(Width, "width", Width)
	SetOnContent("name", Name)
	SetOnContent("value", Value)
	SetOnContent("type", TypeOf)
	SetOnContent("template", Template)
	SetOnCondition(Columns.Size,"cols", Columns)
	SetOnCondition(Rows.Size, "rows", Rows)
	SetOnCondition(Elements.Size, "elements", Elements)
	For Each attr As String In Attributes.Keys
		Dim strVal As Object = Attributes.Get(attr)
		Element.Put(attr,strVal)
	Next
	Return Element
End Sub

Sub AddOnRows(itm As Map)
	Rows.Add(itm)
End Sub

Sub AddOnColumns(itm As Map)
	Columns.Add(itm)
End Sub

Sub AddOnElements(itm As Map)
	Elements.Add(itm)
End Sub

private Sub SetOnContent(Prop As String, PropValue As String)
	If PropValue = "" Then Return
	Element.put(Prop,PropValue)
End Sub

private Sub SetOnCondition(Condition As Int, Prop As String, PropValue As Object)
	If Condition <= 0 Then Return
	Element.put(Prop,PropValue)
End Sub
